#this sets your working directory MAKE SURE TO CHANGE THIS TO A FOLDER OF YOUR CHOICE
setwd("C:/Users/alishakim/Documents/")
#this installs the packages you need to do stuff
install.packages("highcharter")
install.packages("ggplot2")
install.packages("forecast")
install.packages("readxl")
install.packages("htmlwidgets")

#this enables a package
library("highcharter")
#add your own data chart
highchart() %>% 
  hc_chart(type = "column") %>% 
  hc_title(text = "A highcharter chart") %>% 
  #this labels the axis by category (in this case, a range of years)
  hc_xAxis(categories = 2012:2016) %>% 
  #these commands add data manually
  hc_add_series(data = c(3900,  4200,  5700,  8500, 11900),
                name = "Downloads") %>%
  hc_add_series(data = c(4000, 5000, 6000, 7000, 10000), name = "Uploads")

#call some data from the R library
data(diamonds, mpg, package = "ggplot2")
#specify existing variables for chart, group by another variable
hchart(mpg, "scatter", hcaes(x = displ, y = hwy, group = class))

#simple column chart (this is extra, we did not make it in the AUBER session)
hchart(diamonds$cut, colorByPoint = TRUE, name = "Cut")

#forecasting example
library(forecast)
#add the data in the R environment
data("AirPassengers")
#forecast calculation
airforecast <- forecast(auto.arima(AirPassengers), level = 95)
#create a chart with data and forecast
AirPass <- hchart(airforecast)
#this is to view the chart
AirPass

#map example
data(unemployment)

hcmap("countries/us/us-all-all", data = unemployment,
      name = "Unemployment", value = "value", joinBy = c("hc-key", "code"),
      borderColor = "transparent") %>%
  hc_colorAxis(dataClasses = color_classes(c(seq(0, 10, by = 2), 50))) %>% 
  hc_legend(layout = "vertical", align = "right", verticalAlign = "middle",
            floating = FALSE, valueDecimals = 0, valueSuffix = "%")

#map example - single states
data(unemployment)

hcmap("countries/us/us-az-all", data = unemployment,
      name = "Unemployment", value = "value", joinBy = c("hc-key", "code"),
      borderColor = "transparent") %>%
  hc_colorAxis(dataClasses = color_classes(c(seq(0, 10, by = 2), 50))) %>% 
  hc_legend(layout = "vertical", align = "right", verticalAlign = "middle",
            floating = FALSE, valueDecimals = 0, valueSuffix = "%")

#migration data map
library(readxl)
#upload data to the R environment
to_AZ <- read_excel("migration_toArizona.xlsx")
AZ_only <- read_excel("migration_AZonly.xlsx")
#download map data
map <- download_map_data("countries/us/us-all")
hc1 <- highchart(type = "map") %>% 
  hc_plotOptions(map = list(
    allAreas = FALSE,
    joinBy = c("hc-a2", "states"),
    mapData = map
  )) %>% 
  #joinby here: hc-key is highmaps column, code is my matching column
  hc_add_series(name = "Migration to Arizona 2012-2016", data = to_AZ, joinBy = c("hc-key", "code"), color = "#A1A1A1", borderColor = "transparent") %>%
  #these are my own breaks in the data and my own colors (hues of AZ blue)
  hc_colorAxis(dataClasses = color_classes(c(0,2000,4000,7000,15000,54400), colors = c("#d3e1f8", "#91b3ed", "#3a76df", "#19489a", "#0c234b"))) %>% 
  hc_legend(layout = "vertical", align = "right", verticalAlign = "middle",
            floating = FALSE, valueDecimals = 0) %>%
  #this adds AZ as red
  hc_add_series(name = "Arizona", joinBy = c("hc-key", "code"), data = AZ_only, color = "#df072b") 
#this is another way to save as HTML if you don't want to use the Export option in the viewer
#(this goes to working directory)
saveWidget(hc, "to_AZ_migration.html", selfcontained = TRUE, libdir = NULL, background = "white")
####


  

